<?php
namespace Teknisa\FAI\Modules\Relatorio\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;

class Fai03400CustoDeNotasFiscaisDeSaida extends \Zeedhi\Framework\Controller\Report {

    protected $qr2Strategy;
    protected $birtStrategy;
    protected $environment;

    public function __construct(ReportService $reportService, $qr2Strategy, $birtStrategy, $environment) {
        $this->qr2Strategy = $qr2Strategy;
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'FAI03400' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDFILIAL'     => 'P_CDFILIAL',
                'TCDFILIAL'    => 'P_TCDFILIAL',
                'DATAINI'      => 'P_DATAINI',
                'DATAFIM'      => 'P_DATAFIM',
                'CDOPERADOR'   => 'P_CDOPERADOR',
                'NRORG'        => 'P_NRORG'
            )
        ),
        'FAI03401' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'CDFILIAL'     => 'P_CDFILIAL',
                'TCDFILIAL'    => 'P_TCDFILIAL',
                'DATAINI'      => 'P_DATAINI',
                'DATAFIM'      => 'P_DATAFIM',
                'CDOPERADOR'   => 'P_CDOPERADOR',
                'NRORG'        => 'P_NRORG'

            ),

        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $row['CDFILIAL'] = $row['TCDFILIAL'] !== 'T' ? '_' . implode('_',$row['CDFILIAL']) . '_' : "";
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $row['CDOPERADOR'] = $this->environment->getCdOperador();
        $row['NRORG'] = $this->environment->getNrorg();
    }
}